//-*-c++-*-
#ifndef _COMPACT_H
#define _COMPACT_H

#include <tulip/TulipPlugin.h>

/** \addtogroup layout */
/*@{*/
/// Circular.h - An implementation of a circurlar layout.
/** 
 * This plugin is an implementation of a circular layout
 * All nodes are palced arbitrary on circle. 
 *
 * HISTORY:
 *
 * 01/12/99 Verson 0.0.1: Initial release
 *
 * NOTES:
 *
 * This work on general graphs.
 * Let n be the number of nodes, the algorithm complexity is in O(n).
 *
 * AUTHOR:
 *
 * David Auber University Bordeaux I France: Email:auber@tulip-software.com
 */

#include <vector>
#include <tulip/MutableContainer.h>

using namespace std;

class Compact:public Layout { 
public:
  Compact(const PropertyContext &);
  ~Compact();
  bool run();
private:

  //A function to centre a graph
  void centreGraph (Coord centre);
};
/*@}*/
#endif
