//-*-c++-*-
#ifndef _GROW_ROOTS_H
#define _GROW_ROOTS_H

#include <tulip/TulipPlugin.h>

/** \addtogroup layout */
/*@{*/
/// Circular.h - An implementation of a circurlar layout.
/** 
 * This plugin is an implementation of a circular layout
 * All nodes are palced arbitrary on circle. 
 *
 * HISTORY:
 *
 * 01/12/99 Verson 0.0.1: Initial release
 *
 * NOTES:
 *
 * This work on general graphs.
 * Let n be the number of nodes, the algorithm complexity is in O(n).
 *
 * AUTHOR:
 *
 * David Auber University Bordeaux I France: Email:auber@tulip-software.com
 */
class GrowRoots:public Sizes { 
public:
  GrowRoots(const PropertyContext &);
  ~GrowRoots();
  bool run();
  bool check(std::string &errMsg);
  void reset();
private:
  //This function grows the roots of the branches of the tree so
  //that their size takes up the appropriate amount of space.
  void GrowRoots::growBranchRoots (node &root);
};
/*@}*/
#endif
