//-*-c++-*-
#ifndef __HIERLAYOUTONELEVEL_H
#define __HIERLAYOUTONELEVEL_H
#include <tulip/TulipPlugin.h>

using namespace std;

class HierLayoutOneLevel:public Layout { 
public:
  HierLayoutOneLevel(const PropertyContext &);
  ~HierLayoutOneLevel();
  bool run();
  bool check(std::string &);
  void reset();

private:

  //This contains the previous positions of the internal nodes of the
  //quotient graph
  MutableContainer <Coord> prevPos;

  //This contains the previous torque on this node
  MutableContainer <double> prevTau;

  //This function sets up the layout proxies of the passed graph
  void HierLayoutOneLevel::setLayoutProxies (SuperGraph *graph);

  //centres a cluster in its local coordinate frame
  void centreGraph (SuperGraph *cluster);

  //a function that does the layout of the clusters of this graph
  void layoutClusters (SuperGraph *clusterRoot);

  //a function to set the global positions of nodes after the hierarchical
  //laout
  void setGlobalPositions (SuperGraph *rootGraph, SuperGraph *quotientGraph);

  //the following applies torques to the quotient graph nodes
  //in order to prevent edge overlap with elements of the quotient
  //graph
  void applyTorques (SuperGraph *rootGraph, SuperGraph *quotientGraph);

  //A function that computes the torque exerted on the quotient graph
  //node at radBase by the (radNode, opposite) edge.
  inline double computeTorque (node radNode, node opposite, Coord radBase,
			       double rad);

  //Rotates the cluster rotGraph using the torque tau.
  inline void rotateByTau (SuperGraph *rotGraph, double tau, Coord trans);
  
};

#endif









