#include <tulip/TlpTools.h>
#include <tulip/StableIterator.h>
#include <iostream>

using namespace std;

#include <tulip/TulipPlugin.h>
///
const unsigned int max_size = 100;
class RandomDivision:public Metric { 
public:
  RandomDivision(const PropertyContext &context):Metric(context){};

  void dfs (node n, node cameFrom, unsigned int &label, 
	    unsigned int &numVisits, MutableContainer<bool> &visited) {
    if (visited.get (n.id)) return;
    visited.set(n.id, true);
    ++numVisits;
    if (numVisits % max_size == 0) ++label;
    metricProxy->setNodeValue (n, label);
    StableIterator<node> it(superGraph->getInOutNodes(n));
    while(it.hasNext())
      dfs (it.next(), n, label, numVisits, visited);
  }//end dfs

  /**
   * This function is simply the entry point for the plugin.
   */
  bool run() {
    unsigned int cur_label = 1;
    unsigned int counter = 0;
    Iterator<node> *nodes = superGraph->getNodes();
    while(nodes->hasNext()){
      node n = nodes->next();
      metricProxy->setNodeValue(n, cur_label);
      ++counter;
      if (counter % max_size == 0) ++cur_label;
    }delete nodes;
    return true;
  }
};

METRICPLUGIN(RandomDivision,"Random Division", "Daniel Archambault","03/01/2005","Alpha","0","1");
