//-*-c++-*-
#ifndef _StrengthComponent_H
#define _StrengthComponent_H

#include <string>
#include <set>
#include <vector>
#include <map>
#include <tulip/TlpTools.h>
#include <tulip/TulipPlugin.h>

class MetricProxy;

/** \addtogroup clustering */
/*@{*/
class StrengthComponent:public Metric { 
public:
  StrengthComponent(const PropertyContext &);
  ~StrengthComponent();
  bool run();
  bool check(std::string &);
  void reset();
private:
  void   computeNodePartition(double threshold, std::vector< std::set<node> >& );
  double computeMQValue(const std::vector< std::set<node> > &partition, SuperGraph *);
  double findBestThreshold(unsigned int numberOfSteps);
  MetricProxy * values;
};
/*@}*/
#endif
