#include <tulip/TulipPlugin.h>
#include "urlelement.h"
#include "webcrawler.h"

using namespace std;

namespace {
  const char * paramHelp[] = {
    // server
    HTML_HELP_OPEN() \
    HTML_HELP_DEF( "type", "string" ) \
    HTML_HELP_DEF( "default", "www.tulip-software.org" ) \
    HTML_HELP_BODY() \
    "This parameter defines the web server that you want to address." \
    HTML_HELP_CLOSE(),
    // degree
    HTML_HELP_OPEN() \
    HTML_HELP_DEF( "type", "string" ) \
    HTML_HELP_DEF( "default", "index.html" ) \
    HTML_HELP_BODY() \
    "This parameter defines the first web page to visit"\
    HTML_HELP_CLOSE(),
    //
    HTML_HELP_OPEN() \
    HTML_HELP_DEF( "type", "Unsigned int" ) \
    HTML_HELP_DEF( "default", "1000" ) \
    HTML_HELP_BODY() \
    "This parameter defines the maximum number of nodes allowed in the extracted graph." \
    HTML_HELP_CLOSE()
  };
}

struct WebImport:public ImportModule {
  WebImport(ClusterContext context):ImportModule(context) {
    addParameter<string>("Server",paramHelp[0],"www.tulip-software.org");
    addParameter<string>("Web Page",paramHelp[1],"index.html");
    addParameter<int>("Max size",paramHelp[2],"1000");
    addParameter<bool>("Other server",paramHelp[2],"false");
  }
  
  bool import(const string &name) {
    string server = "www.tulip-software.org";
    string url = "index.html";
    bool others = false;
    int maxsize = 1000;
    if (dataSet != 0) {
      dataSet->get("Server", server);
      dataSet->get("Web Page", url);
      dataSet->get("Max size", maxsize);
      dataSet->get("Other server",others);
    }
    
    UrlElement urlElement;
    urlElement.server = server;
    urlElement.url = string("/") + url;
    urlElement.serverport = 80;
    urlElement.data = "";
    
    vector<UrlElement> mySite;
    mySite.push_back(urlElement);
    WebCrawler spider(mySite, superGraph, maxsize);
    spider.start();
    return true;
  }
};

IMPORTPLUGIN(WebImport,"WWW","Auber","15/11/2004","0","0","1")
