/***************************************************************************
 *   Copyright (C) 2004 by Auber David                                     *
 *   auber@tulip-software.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef URLELEMENT_H
#define URLELEMENT_H

/**
@author Auber David
*/
#include <string>

class UrlElement {
public:
  UrlElement();
  UrlElement(const UrlElement &c);
  void load();
  void clear();
  bool isHtmlPage();

private:  
  void fill(std::string &result);
  void closeFD();
  int siteconnect(const std::string &server, const std::string &url,
		  const int serverport, bool headonly);

public :
  std::string url;
  std::string server;
  std::string data;
  unsigned int serverport;

private:
  int fd;			
};

namespace std {
template <>
  struct less<UrlElement> {
    bool operator()(const UrlElement &lhs, const UrlElement &rhs) {
      if (lhs.server.compare(rhs.server) < 0 ) return true;
      if (lhs.server.compare(rhs.server) > 0 ) return false;
      if (lhs.url.compare(rhs.url) < 0 ) return true;
      return false;
    }
  };
}
#endif
