/***************************************************************************
 *   Copyright (C) 2004 by Auber David                                     *
 *   auber@tulip-software.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef WEBCRAWLER_H
#define WEBCRAWLER_H

/**
@author Auber David
*/
#include <string>
#include <vector>
#include <set>
#include <map>
#include <tulip/SuperGraph.h>
#include <tulip/Node.h>
#include <tulip/StringProxy.h>
#include "urlelement.h"

class WebCrawler {
public:
  WebCrawler(const std::vector<UrlElement> &startUrls, SuperGraph *, unsigned int = INT_MAX);
  void start();

private:
  bool nextUrl(UrlElement &url);
  void parseHtml (const UrlElement &);
  void parseUrl (const std::string &, const UrlElement &);
  void addUrl (const UrlElement &);
  void addServer (const std::string &);
  void addNode(const UrlElement &);
  void addEdge(const UrlElement &,const UrlElement &);
  void findAndTreatUrls(const std::string&, const std::string&, const UrlElement &);

public:
  SuperGraph *graph;
  
private:
  std::deque<UrlElement> toVisit;
  std::set<UrlElement> visited;
  std::map<UrlElement,node> nodes;
  StringProxy *labels;
  unsigned int maxSize;
};

#endif
