#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <iostream>
#include <fstream>
#include <vector>
#include <tulip/TlpTools.h>
#include "urlelement.h"
#include "webcrawler.h"

using namespace std;

int main(int argc, char **argv) {
  tlp::initTulipLib();
  tlp::loadPlugins();
  UrlElement url;
  url.server = "www.labri.fr";
  url.url = "/";
  url.serverport = 80;
  url.data = "";

  SuperGraph *graph = tlp::newSuperGraph();  
  vector<UrlElement> mySite;
  mySite.push_back(url);
  WebCrawler spider(mySite, graph, 10000);
  spider.start();
  ofstream os("WebGraph.tlp");
  DataSet tmp;
  tlp::exportGraph(spider.graph,os,"tlp",tmp);
  return 0;
} // end, main()
