#include <tulip/Face.h>

using namespace std;

#include <iostream>
#include <ostream>
#include <algorithm>


unsigned int Face::nf=0;



//============================================================
// FACE
//============================================================
Face::Face(){
  this->clear();
  nf++;
  ident=nf;
}

//============================================================
Face::Face(Face* f){
  assert(f); 
  (*this) = (*f);
  nf++;
  ident=nf;
}

//============================================================
Face::~Face(){}

//============================================================
void Face::addEdge(const edge e, const edge prec){
  assert(e.isValid());
  if(!prec.isValid())
    this->push_back(e);
  else{
    vector<edge>::iterator it = find(this->begin(), this->end(),prec);
    assert(it != this->end());
    this->insert(it+1, e);
  }
}

//============================================================
void Face::delEdge(const edge e){
  vector<edge>::iterator it = find(this->begin(), this->end(),e);
  assert(it != this->end());
  this->erase(it, it+1);
}

//============================================================
void Face::delEdges(const edge first, const edge last){  
  // first and last included
  vector<edge>::iterator it_first = find(this->begin(), this->end(),first);
  assert(it_first != this->end());
  vector<edge>::iterator it_last = find(this->begin(), this->end(),last);
  assert(it_last != this->end());
  this->erase(it_first, it_last+1);
}

//============================================================
bool Face::containEdge(const edge e) const{
  vector<edge>::const_iterator it = find(this->begin(), this->end(),e);
  return (it != this->end());
}

//============================================================
edge Face::getLastEdge() const{
  if(this->size() == 0) return edge();
  else return (*this)[this->size()-1];
}

//============================================================
edge Face::getFirstEdge() const{
  if(this->size() == 0) return edge();
  else return (*this)[0];
}

//============================================================
edge Face::succEdge(const edge e) const{
  vector<edge>::const_iterator it = find(this->begin(), this->end(),e);
  assert(it != this->end());
  if((it+1) == this->end())
    return this->front();
  else  return *(it+1);
}

//============================================================
edge Face::precEdge(const edge e) const{
  vector<edge>::const_iterator it = find(this->begin(), this->end(),e);
  assert(it != this->end());
  if(it == this->begin())
    return this->back();
  else  return *(it-1);
}

//============================================================
ostream & operator << (ostream &os,const Face& F){
  os<<"edges ";
  for(unsigned int i = 0; i<F.size(); i++){
    os<<F[i].id<<"  ";
  }
  return os<<endl;
}


