//-*-c++-*-
/**
 Author: Sophie BARDET & Alexandre BURNETT
 Email : sophie.bardet@gmail.com, aburnett397@gmail.com
 Last modification : 19/06/2005
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by  
 the Free Software Foundation; either version 2 of the License, or     
 (at your option) any later version.
*/

#ifndef Tulip_SuperGraphMapTest_h
#define Tulip_SuperGraphMapTest_h

#include <tulip/SuperGraphMap.h>
#include <tulip/TlpTools.h>

#include <cppunit/TestFixture.h>
#include <cppunit/TestSuite.h>

class SuperGraphMapTest : public CppUnit::TestFixture{
  
private :
  SuperGraph* graph;
  SuperGraphMap* carte;

  std::vector<edge> edges;
  std::vector<node> nodes; 

  void build();
  void build2();
  void build3();
  bool containFace(Face* f);
  
public :
  void setUp(){
    graph = tlp::newSuperGraph();
    carte = new SuperGraphMap(graph);
    edges.clear();
    nodes.clear();
  }
  
  void tearDown(){
    delete carte;
    delete graph;
  }

  void testAddEdgeMap();
  void testNbFaces();

  void testUpdate();

  void testSplitFace();
  void testMergeFaces();

  void testSuccCycleEdge();   
  void testPrecCycleEdge();  

  void testComputeFaces();

  static CppUnit::Test *suite();

};

#endif
