
/** \addtogroup layout */
/*@{*/
/// SmashingPeacock.cpp -- The new smashing peacock algorithm based on lgl.
/**
 *
 * Implementation by D. Archambault
 *
 */
#include <tulip/TulipPlugin.h>

class SmashingPeacock : public Layout {
 private:
  unsigned int lglCounter;
  SelectionProxy *mst;
  node mstRoot;
  void setMST ();
  void prepPeacock (SuperGraph *hierarchy, 
		    node treeRoot, node cameFrom, node biconCompRoot);
 public:
  inline SmashingPeacock (const PropertyContext &context):Layout (context) {
    lglCounter = 0;
  }
  inline ~SmashingPeacock () {}
  bool run();
  bool check(std::string &);
  void reset();
};
